      SUBROUTINE WRITEP(KFILDO,KFILIO,IPACK,NWORDS,NTOTBY,NTOTRC,
     1                  L3264B,IER)
C
C        SEPTEMBER 1994   GLAHN   TDL   MOS-2000
C        JANUARY   1997   GLAHN   REMOVED TAPE-RELATED CODE
C        DECEMBER  1997   GLAHN   CHANGED PREDX2 TO PACKV IN PURPOSE
C        JUNE      1999   GLAHN   CHANGED PRINT AT D158
C        APRIL     2000   DALLAVALLE   MODIFIED FORMAT STATEMENTS TO
C                                 CONFORM TO FORTRAN 90 
C                                 STANDARDS ON THE IBM SP
C        SEPTEMBER 2000   GLAHN   REMOVED /D**** DIAGNOSTIC
C
C        PURPOSE
C           TO WRITE FOR U201 IN PACKV THE INTERPOLATED DATA.
C           SINCE ALL WRITING MUST BE DONE TO A DISK FILE, ANY REFERENCE
C           TO TAPE DENSITY, LENGHT, ETC. IS NOT NECESSARY.  THIS
C           MAY BE USEFUL IN OTHER PROGRAMS, SUCH AS U700.
C   
C        DATA SET USE
C            KFILDO - UNIT NUMBER OF OUTPUT (PRINT) FILE.  (OUTPUT)
C            KFILIO - UNIT NUMBER OF INTERPOLATED OUTPUT FILE.  (OUTPUT)
C
C        VARIABLES
C              KFILDO = UNIT NUMBER OF OUTPUT (PRINT) FILE.  (INPUT)
C              KFILIO = UNIT NUMBER OF INTERPOLATED OUTPUT FILE.  (INPUT)
C            IPACK(K) = THE PACKED DATA TO WRITE (K=1,NWORDS).  (INPUT)
C              NWORDS = THE NUMBER OF WORDS IN IPACK( ).  ALSO TREATED
C                       AS ITS DIMENSION.  (INPUT)
C              NTOTBY = THE TOTAL NUMBER OF BYTES IN THE FILE.  IT IS
C                       UPDATED WHEN THE DATA IN IPACK( ) ARE WRITTEN.
C                       (INPUT-OUTPUT)
C              NTOTRC = THE TOTAL NUMBER OF RECORDS IN THE FILE.  IT IS
C                       UPDATED AS NEEDED.  (INPUT-OUTPUT)
C              L3264B = INTEGER WORD LENGTH OF MACHINE BEING USED.
C                 IER = STATUS RETURN.
C                       0  = GOOD RETURN.
C                       70 = ERROR WRITING RECORD.
C
C         NONSYSTEM SUBROUTINES CALLED
C            NONE
C
      DIMENSION IPACK(NWORDS)
C
      DATA NTRASH/0/
C
      IER=0
C
      IF(L3264B.EQ.32)THEN
         NTOTBY=NTOTBY+NWORDS*4+8
      ELSE
         NTOTBY=NTOTBY+NWORDS*8+8
      ENDIF
C      
      NTOTRC=NTOTRC+1
C
C        NOTE IN WRITING THAT THE PACKED RECORD IS PRECEEDED BY
C        THE NUMBER OF BYTES IN IPACK( ).  TO ACCOMMODATE A 64-BIT
C        MACHINE, RECORDS MUST BE WRITTEN IN 64-BIT CHUNCKS.
C        FOR A 32-BIT MACHINE, THIS MEANS WRITING A DUMMY 32-BIT
C        WORD PRECEEDING THE NUMBER OF BYTES.
C
 150  IF(L3264B.EQ.32)THEN
         NBYTES=NWORDS*4
         WRITE(KFILIO,IOSTAT=IOS,ERR=160)NTRASH,NBYTES,IPACK
      ELSE
         NBYTES=NWORDS*8
         WRITE(KFILIO,IOSTAT=IOS,ERR=160)NBYTES,IPACK
      ENDIF
C
D     WRITE(KFILDO,158)NWORDS,NTOTBY,NTOTRC
D158  FORMAT(/' WRITING DATA IN WRITEP'/
D    1        '    NWORDS ='I10  '   WORDS WRITTEN'/
D    2        '    NTOTBY ='I10  '   TOTAL BYTES IN FILE'/
D    4        '    NTOTRC ='I10  '   TOTAL RECORDS IN FILE')
      GO TO 200
C
 160  WRITE(KFILDO,161)KFILIO,IOS
 161  FORMAT(' ****ERROR WRITING PACKED RECORD IN WRITEP',
     1       ' ON UNIT NO.',I3,', IOSTAT =',I5,'.')
     
      IER=70
 200  RETURN
      END
